=== debian/changelog ===
debian-reference (2.75) unstable; urgency=medium

  [ Holger Wansing ]
  * Update Italian translation. Closes: #924071

  [ Osamu Aoki ]
  * Fixed broken symlink (in 2.74/unstable). Closes: #910153
  * Fixed DEB_BUILD_OPTIONS.  Closes: #907779 

 -- Osamu Aoki <osamu@debian.org>  Sun, 10 Mar 2019 22:27:19 +0900

debian-reference (2.74) unstable; urgency=medium

  [ Boyuan Yang ]
  * Re-enable PDF generation for zh-cn and zh-tw.
  * Update translations.
  * Bump Standards-Version to 4.1.4 (no change needed)
  * Canonicalize Vcs fields in debian/control file.

  [ Holger Wansing]
  * Fix typo ('Command requires root privileges'). Closes: #908283

 -- Osamu Aoki <osamu@debian.org>  Mon, 04 Mar 2019 23:16:18 +0900
