## debian-reference 2.76

=== debian/changelog ===
debian-reference (2.76) unstable; urgency=medium

  * Complete translation for de, it, ja, pt, and zh-cn.
    Closes: #924863
  * Update filepath to comply with doc-base CGI script restrictions.
    Closes: #900360, #924686
  * Add lintian override for missing-depends-on-sensible-utils,
  * Update package and popcon data entity.
  * Ready for buster release by setting buster as stable release.

 -- Osamu Aoki <osamu@debian.org>  Thu, 21 Mar 2019 23:23:38 +0900
