=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends-Indep: dblatex,
                      docbook-xml,
                      docbook-xsl,
-                     libopencc2-data,
                      fonts-liberation2,
                      fonts-vlgothic,
                      fonts-wqy-microhei,
+                     libopencc2-data,
                      libxml2-utils,
                      locales-all | locales,
                      opencc,
@@ -46,11 +46,11 @@
 Package: debian-reference
 Architecture: all
 Depends: debian-reference-en, ${misc:Depends}
-Recommends: debian-reference-fr,
+Recommends: debian-reference-de,
+            debian-reference-es,
+            debian-reference-fr,
             debian-reference-it,
             debian-reference-ja,
-            debian-reference-es,
-            debian-reference-de,
             debian-reference-pt,
             debian-reference-zh-cn,
             debian-reference-zh-tw
