## debian-reference 2.76ubuntu1

=== Makefile ===
--- 
+++ 
@@ -21,10 +21,10 @@
 # from stable -> testing just after stable release
 
 # This is normal
-RELEASE_STATE := testing
+#RELEASE_STATE := testing
 
 # this is just before freeze
-#RELEASE_STATE := stable
+RELEASE_STATE := stable
 
 # TMP_DIR_DR is not mean to be set to generic TMPDIR like /tmp ~/.tmp
 ifndef TMP_DIR_DR
@@ -243,8 +243,8 @@
 	echo "<!ENTITY Codename-stable  \"Buster\">"			>> common.ent
 	echo "<!ENTITY codename-testing  \"bullseye\">"			>> common.ent
 	echo "<!ENTITY Codename-testing  \"Bullseye\">"			>> common.ent
-	echo "<!ENTITY codename-nexttesting  \"bullseye+1\">"		>> common.ent
-	echo "<!ENTITY Codename-nexttesting  \"Bullseye+1\">"		>> common.ent
+	echo "<!ENTITY codename-nexttesting  \"bookworm\">"		>> common.ent
+	echo "<!ENTITY Codename-nexttesting  \"Bookworm\">"		>> common.ent
 else
 	# Live with 2 year testing release from sid/unstable
 	echo "<!ENTITY codename-stable  \"stretch\">"			>> common.ent
