=== debian/changelog ===
debian-reference (2.76ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 31 Mar 2020 12:05:09 +0200
