=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                      locales-all | locales,
                      opencc,
                      po4a,
-                     python,
+                     python2,
                      texlive-lang-chinese,
                      texlive-lang-english,
                      texlive-lang-french,
