=== debian/rules ===
--- 
+++ 
@@ -53,9 +53,10 @@
 	    id) LANGX="Bahasa Indonesia" ;; \
 	    *) LANGX="$$x" ;; \
 	  esac ; \
-	  sed  -e "s/@@/$$XX/" < all.links-in  >$(MANUAL)-$${XX}.links ; \
-	  sed  -e "s/@@/$$XX/" < all.install-in  >$(MANUAL)-$${XX}.install ; \
-	  sed  -e "s/@@/$$XX/" -e "s/@LANG@/$$LANGX/" < all.doc-base-in  >$(MANUAL)-$${XX}.doc-base ; \
+	  sed  -e "s/@@/$$XX/g" < all.links-in  >$(MANUAL)-$${XX}.links ; \
+	  sed  -e "s/@@/$$XX/g" < all.install-in  >$(MANUAL)-$${XX}.install ; \
+	  sed  -e "s/@@/$$XX/g" -e "s/@LANG@/$$LANGX/g" < all.doc-base-in  >$(MANUAL)-$${XX}.doc-base ; \
+	  sed  -e "s/@@/$$XX/g" < all.lintian-overrides-in >$(MANUAL)-$${XX}.lintian-overrides ; \
 	done
 	dh_auto_build $(BUILDOPT) -- \
 		"LANGALL=$(LANGALL)" \
