## debian-reference 2.76ubuntu1+10.0trisquel3

=== debian/changelog ===
debian-reference (2.76ubuntu1+10.0trisquel3) nabia; urgency=medium

  * Remove references to non-free repos #5950, remove already applied
    patch

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 26 Jun 2021 20:01:19 +0000
