## debian-reference 2.76+nmu1

=== debian/changelog ===
debian-reference (2.76+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 11:15:32 +0800
