=== debian/changelog ===
debian-reference (2.77) unstable; urgency=medium

  [ Holger Wansing ]
  * libopencc2-data has been replaced by libopencc-data. Dependency
    can be removed, since package opencc has an implicit hard dependency on
    the data package already. Closes: #964674, #979524

  [ Osamu Aoki ]
  * Mention locales-all package. Closes: #953075
  * Update printing for post-CUPS 1.6. Closes: #941801
  * Convert source to XML.

  [ Stuart Prescott ]
  * Migrate to Python3. Closes: #942942
  * Add CI to automate build tests on Salsa. Closes: #972371

  [ xiao sheng wen (肖盛文) ]
  * get package info from oldstable and stable. Closes: #972437

 -- Osamu Aoki <osamu@debian.org>  Sun, 10 Jan 2021 15:36:06 +0900
